#pragma once
#include <string>
#include <fstream>
#include "codec.h"
#include "DynamicArray.h"

class CBase64Filter
{
private:
	union{
		std::ifstream *m_pif;
		std::ofstream *m_pof;
	};
	std::string m_str;

public:
	CBase64Filter(std::ifstream &f)
	{ m_pif = &f; }
	CBase64Filter(std::ofstream &f)
	{ m_pof = &f; }
	void operator >>(std::string &str)
	{
		(*m_pif) >> m_str;
		DynamicArray<char> buf((m_str.length()*3)/4 + 4);
		DecodeBase64(buf, m_str.c_str(), m_str.c_str()+m_str.length());
		str = buf;
	}
	std::ofstream& operator <<(const std::string &str)
	{
		DynamicArray<char> buf(((str.length()+1)*4)/3 + 5);
		EncodeBase64(str.c_str(), buf, str.length()+1);
		(*m_pof) << buf;
		return *m_pof;
	}
};

