#include "StdAfx.h"
#include <Commdlg.h>
#include ".\defaultspage.h"
#include "resource.h"

const static LPCSTR NOTIFY_TYPE_NAME[] = {
	"x",
	"G[",
	"",
	"₢킹",
	"bZ[WM",
	"[M",
	"t@CM",
	"ڑ",
	"ؒf",
	"oIC",
	"oItC",
	"orW[",
};

const static LPCSTR MARK_TYPE_NAME[] = {
	"}[NȂ",
	"V",
	"Vorŋ",
	"vr[",
};

//******************************************************************
// 
//******************************************************************

CDefaultsPage::CDefaultsPage(DefaultSettings &set)
: m_bFontInited(false)
{
	m_nIDTemplate = IDD_PP_DEFAULT;
	m_pset = &set;
}

CDefaultsPage::~CDefaultsPage(void)
{
}

//******************************************************************
// 
//******************************************************************
BOOL CDefaultsPage::DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uMsg ){
	case WM_NOTIFY:
		switch( ((LPNMHDR)lParam)->code ){
		case TTN_GETDISPINFO:
		    SendMessage(((LPNMHDR)lParam)->hwndFrom, TTM_SETMAXTIPWIDTH, 0, 500);
			((LPNMTTDISPINFO)lParam)->lpszText = MAKEINTRESOURCE(((LPNMTTDISPINFO)lParam)->lParam);
			((LPNMTTDISPINFO)lParam)->hinst = m_hInstance;
			break;

		default:
			return FALSE;
		}
		return TRUE;
	case WM_COMMAND:
		switch( LOWORD(wParam) ){
		case IDC_REF:
			OnRef();
			break;
		default:
			return FALSE;
		}
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

BOOL CDefaultsPage::InitDlgCtrl()
{
	HWND hItem;

	// [`FbNݒ
	SetItemText(IDC_DEF_INTERVAL, m_pset->interval);
	SetItemText(IDC_DEF_NOTIFYTERM, m_pset->notify_term);
	SetCheck(IDC_DEF_EACH, m_pset->notify_each);
	SetItemText(IDC_DEF_TIMEOUT, m_pset->timeout/1000);

	// \ݒ
	SetItemText(IDC_DEF_MAXMAIL, m_pset->max_mail);
	SetItemText(IDC_DEF_MAILTERM, m_pset->show_term/(60*60));
	SetItemText(IDC_DEF_PREV, m_pset->preview_linenum);
	SetCheck(IDC_DEF_AUTOPRVW, m_pset->auto_preview);

	SetItemText(IDC_MUA_PATH, m_pset->mua_path.c_str());
	SetCheck(IDC_COM_PROTO, m_pset->comlog_type == RC_COM);
	SetCheck(IDC_COM_NEW, m_pset->comlog_type == RC_NEW);
	SetCheck(IDC_COM_NONE, m_pset->comlog_type == RC_NOLOG);
	SetItemText(IDC_MAX_NOTIFY, m_pset->max_notify);

	// }[N
	hItem = GetDlgItem(IDC_MARK_TYPE);
	for( int i = 0; i < NUM_OF_MARK; i++ )
		::SendMessage(hItem, CB_ADDSTRING, 0, (LPARAM)MARK_TYPE_NAME[i]);
	::SendMessage(hItem, CB_SETCURSEL, (LPARAM)m_pset->mark_type, 0);

	// 1ʂƒʒm
	hItem = GetDlgItem(IDC_MAIL_NOTIFY);
	for( int i = 0; i <= NMNI_BUSY; i++ )
		::SendMessage(hItem, CB_ADDSTRING, 0, (LPARAM)NOTIFY_TYPE_NAME[i]);
	::SendMessage(hItem, CB_SETCURSEL, (LPARAM)m_pset->mail_notify_type, 0);

	// Vʒm
	hItem = GetDlgItem(IDC_MNUM_NOTIFY);
	for( int i = 0; i <= NMNI_BUSY; i++ )
		::SendMessage(hItem, CB_ADDSTRING, 0, (LPARAM)NOTIFY_TYPE_NAME[i]);
	::SendMessage(hItem, CB_SETCURSEL, (LPARAM)m_pset->mnum_notify_type, 0);

	// tHg
	if( ! m_bFontInited ) InitFont();
	hItem = GetDlgItem(IDC_FONT_NAME);
	for( int i = 0; i < (int)m_fontnames.size(); i++ )
		::SendMessage(hItem, CB_ADDSTRING, 0, (LPARAM)m_fontnames[i].c_str());
	::SendMessage(hItem, CB_SELECTSTRING, 0, (LPARAM)m_pset->font_name.c_str());
	SetItemText(IDC_FONT_SIZE, m_pset->font_size);

	// vr[}
	SetItemText(IDC_MAX_AUTO_PREVIEW, m_pset->max_auto_preview);


	// c[`bv
	int cid = IDC_DEF_INTERVAL;
	int sid =IDS_DEF_INTERVAL;
	m_tip.Create(m_hInstance, m_hDlgWnd);
	for( ; cid <= IDC_DEFAULT_CTRL_END; cid++, sid++ ){
		m_tip.AddToolToToolTip(m_hDlgWnd, GetDlgItem(cid), sid);
	}
	m_tip.Begin();

	return TRUE;
}

void CDefaultsPage::GetDlgCtrlValue()
{
	int ret;

	m_pset->interval		= GetEditBoxInt(IDC_DEF_INTERVAL);
	m_pset->notify_term		= GetEditBoxInt(IDC_DEF_NOTIFYTERM);
	m_pset->notify_each		= GetCheck(IDC_DEF_EACH);
	m_pset->timeout			= GetEditBoxInt(IDC_DEF_TIMEOUT) * 1000;

	m_pset->max_mail		= GetEditBoxInt(IDC_DEF_MAXMAIL);
	m_pset->show_term		= GetEditBoxInt(IDC_DEF_MAILTERM) * 60 * 60;
	m_pset->preview_linenum = GetEditBoxInt(IDC_DEF_PREV);
	m_pset->auto_preview	= GetCheck(IDC_DEF_AUTOPRVW);

	GetEditBoxText(IDC_MUA_PATH, m_pset->mua_path);
	m_pset->comlog_type = GetCheck(IDC_COM_PROTO) ?
		RC_COM: (GetCheck(IDC_COM_NEW) ? RC_NEW: RC_NOLOG);
	m_pset->max_notify = GetEditBoxInt(IDC_MAX_NOTIFY);
	m_pset->mark_type = (RE_MARK)::SendMessage
		(GetDlgItem(IDC_MARK_TYPE), CB_GETCURSEL, 0, 0);
	m_pset->mail_notify_type = (NotifyIconType)::SendMessage
		(GetDlgItem(IDC_MAIL_NOTIFY), CB_GETCURSEL, 0, 0);
	m_pset->mnum_notify_type = (NotifyIconType)::SendMessage
		(GetDlgItem(IDC_MNUM_NOTIFY), CB_GETCURSEL, 0, 0);
	ret = ::SendMessage(GetDlgItem(IDC_FONT_NAME), CB_GETCURSEL, 0, 0);
	if( 0 <= ret && ret < (int)m_fontnames.size() )
		m_pset->font_name = m_fontnames[ret];
	m_pset->font_size = GetEditBoxInt(IDC_FONT_SIZE);

	m_pset->max_auto_preview = GetEditBoxInt(IDC_MAX_AUTO_PREVIEW);
}

//******************************************************************
// 
//******************************************************************
void CDefaultsPage::InitFont()
{
	LOGFONT lf;
	HDC hdc;
	EnumInfo ei;
	HWND hItem;

	hItem = GetDlgItem(IDC_FONT_NAME);
	lf.lfCharSet = DEFAULT_CHARSET;
	lf.lfFaceName[0] = '\0';
	lf.lfPitchAndFamily = 0;
	ei.pfonts = &m_fontnames;

	hdc = ::GetDC(hItem);
	::EnumFontFamiliesEx(hdc, &lf, (FONTENUMPROC)EnumFont, (LPARAM)&ei, 0);
	::ReleaseDC(hItem, hdc);

	m_bFontInited = true;
}

void CDefaultsPage::OnRef()
{
	OPENFILENAME ofn;
	char buf[MAX_PATH];
	std::string path;

	GetEditBoxText(IDC_MUA_PATH, path);
	strcpy_s(buf, path.c_str());
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = m_hDlgWnd;
	ofn.hInstance = m_hInstance;
	ofn.lpstrFilter = "AvP[V(.exe)\0*.exe\0";
	ofn.lpstrFile = buf;
	ofn.nMaxFile = sizeof(buf);
	ofn.Flags = (OFN_ENABLESIZING);

	if( GetOpenFileName(&ofn) ){
		SetItemText(IDC_MUA_PATH, buf);
	}
}

int CALLBACK CDefaultsPage::EnumFont(ENUMLOGFONTEX *pelfex,
	NEWTEXTMETRICEX* /*pntmex*/, DWORD /*fontType*/, LPARAM lParam)
{
	EnumInfo &ei = *(EnumInfo*)lParam;

	if( pelfex->elfLogFont.lfFaceName[0] == '@' ) return TRUE;
	if( ei.pfonts->size() > 0 && strcmp(pelfex->elfLogFont.lfFaceName, ei.pfonts->back().c_str()) == 0 )
		return TRUE;

	ei.pfonts->push_back(pelfex->elfLogFont.lfFaceName);
	return TRUE;
}
