#pragma once
#include "mailserver.h"
#include "server_info.h"

class CImap4Server :
	public CMailServer
{
private:
//	const static int IMAP4_PORT = 143;
	enum
	{
		TEXT,
		AUTH_NUM,
	};
	const static LPCSTR AUTH_TYPE_NAME[AUTH_NUM];
	const static int CMD_BUF_LEN = 256;
	const static char RES_OK[];
	const static int RES_OK_LEN = 2;

public:
	CImap4Server(ServerInfo &info, CComLog *pcl, HANDLE hStop);
	const CImap4Server& operator =(const CImap4Server&)
	{ _ASSERT(FALSE); }
	~CImap4Server(void);

public:
	virtual void GetUIDList(MailIDMap &map);
	virtual void GetMail(LPCSTR uid, std::string &mail, int linenum);
	virtual void GetMailHeaders(NumberMap &mails);
	virtual void DeleteMail(LPCSTR uid);
	virtual u_short GetDefaultPort(RE_SECURITY security);

public:
	static int GetNumOfAuthType()
	{ return AUTH_NUM; }
	static LPCSTR GetAuthTypeName(int no)
	{ return AUTH_TYPE_NAME[no]; }

protected:
	virtual void Authorize();
	virtual void Quit();

protected:
	void SelectInboxRead();
	void SelectInboxWrite();
	void CloseMailbox();
	bool CheckRes(LPCSTR tag);
	bool IsGoodResponce(LPCSTR line, LPCSTR tag);
	void RecvLiteralString(LPSTR buf, int len);
};
