#include "StdAfx.h"
#include <process.h>
#include ".\mailchecker.h"
#include "Imap4Server.h"
#include "Pop3Server.h"
#include "mleak.h"

//******************************************************************
// 
//******************************************************************

CMailChecker::CMailChecker(CRiffNsm *pNsm, CGID gid, LPCSTR lpURL, LPCSTR lpPassword)
{
	ThreadParam p;

	p.pNsm = pNsm;
	p.gid = gid;
	p.nAcc = -1;
	p.pURL = lpURL;
	p.pPass = lpPassword;
	CreateWorkThread(p);
}

CMailChecker::CMailChecker(CRiffNsm *pNsm, CGID gid, int nAcc, LPCSTR lpPassword)
{
	ThreadParam p;

	p.pNsm = pNsm;
	p.gid = gid;
	p.nAcc = nAcc;
	p.pPass = lpPassword;
	CreateWorkThread(p);
}

CMailChecker::~CMailChecker(void)
{
	::SetEvent(m_hStop);
	PostMessage(WM_QUIT);

	// XbhÎ҂
//	while( ::WaitForSingleObjectEx(m_hThread, INFINITE, TRUE) == WAIT_IO_COMPLETION );
	::WaitForSingleObject(m_hThread, INFINITE);
	::CloseHandle(m_hThread);
	::CloseHandle(m_hStop);
}

//******************************************************************
// 
//******************************************************************

//******************************************************************
// 
//******************************************************************

// ƃXbh쐬
void CMailChecker::CreateWorkThread(ThreadParam &param)
{
	m_hStop = ::CreateEvent(NULL, TRUE, FALSE, NULL);
	_ASSERT( m_hStop != INVALID_HANDLE_VALUE );
	param.hStop = m_hStop;

	param.hEvt = ::CreateEvent(NULL, FALSE, FALSE, NULL);
	_ASSERT( param.hEvt != INVALID_HANDLE_VALUE );

	m_hThread = (HANDLE)_beginthreadex(NULL, 0, RiffThread, &param, 0, &m_threadID);

	// Xbh̏܂ő҂
	::WaitForSingleObject(param.hEvt, INFINITE);
	::CloseHandle(param.hEvt);
}

//******************************************************************
// 
//******************************************************************

RE_PROTOCOL CMailChecker::SetServerInfoFromURL(ServerInfo &info, LPCTSTR lpURL)
{
	LPCTSTR st, ed;
	RE_PROTOCOL proto;

	if( strncmp(lpURL, "pop://", 6) == 0 ){
		proto = RP_POP3;
		st = lpURL + 6;
	}else if( strncmp(lpURL, "imap://", 7) ){
		proto = RP_IMAP4;
		st = lpURL + 7;
	}else{
		return RP_ERROR;
	}

	ed = strchr(st, '@');
	if( ed == NULL ) return RP_ERROR;
	info.user.assign(st, ed - st);
	st = ed + 1;

	ed = strchr(st, ':');
	if( ed != NULL ){
		info.host.assign(st, ed - st);
		st = ed + 1;

		ed = strchr(st, '/');
		if( ed == NULL ) return RP_ERROR;
		info.port = static_cast<u_short>(atoi(st));
		st = ed + 1;
	}else{
		ed = strchr(st, '/');
		if( ed == NULL ) return RP_ERROR;
		info.host.assign(st, ed - st);
		st = ed + 1;

		info.port = 0;
	}

	if( proto == RP_POP3 ){
		for( int i = 0; i < CPop3Server::GetNumOfAuthType(); i++ )
			if( _stricmp(CPop3Server::GetAuthTypeName(i), st) == 0 )
				info.auth = i;
	}else{
		for( int i = 0; i < CImap4Server::GetNumOfAuthType(); i++ )
			if( _stricmp(CImap4Server::GetAuthTypeName(i), st) == 0 )
				info.auth = i;
	}

	return proto;
}

void CMailChecker::CreateMsgQueue()
{
	MSG msg;
	PeekMessage(&msg, NULL, WM_USER, WM_USER, PM_NOREMOVE);
}

void CMailChecker::LoadAccSettings(AccSettings &acc, int nAcc, LPCSTR lpURL, LPCSTR lpPassword)
{
	if( nAcc == -1 ){
		RIFF_SETTINGS.GetDefaultSettings(acc);
		acc.info.pass = lpPassword;
		acc.c_set.protocol = SetServerInfoFromURL(acc.info, lpURL);
		acc.u_set.account = ((acc.c_set.protocol == RP_POP3) ? "pop_": "imap_")
			+ acc.info.host + "_" + acc.info.user;
	}else{
		RIFF_SETTINGS.GetAccSettings(nAcc, acc);
	}
}

unsigned __stdcall CMailChecker::RiffThread(void* param)
{
	// SetEvent(p.hEvt)  param ͖ۏɂȂ̂ŃRs[K{
	ThreadParam p = *(ThreadParam*)param;
	AccSettings acc;

	CreateMsgQueue();
	LoadAccSettings(acc, p.nAcc, p.pURL, p.pPass);

	SetEvent(p.hEvt);
	// ȍ~ param ͖ۏ

	CMailCheckerThread thread(p.pNsm, p.gid, acc, p.nAcc, p.hStop);
	thread.RiffThreadBody();

	return 0;
}

