#pragma once
#include "RiffSettings.h"
#include "MailCheckerThread.h"

class CMailChecker
{
private:
	struct ThreadParam
	{
		HANDLE hEvt;		// Xbhʒm󂯎
		HANDLE hStop;		// Xbh~ߔsp
		CRiffNsm *pNsm;
		u_int gid;
		int nAcc;
		LPCSTR pURL;
		LPCSTR pPass;
	};

private:
	unsigned int m_threadID;	// Xbhʎq
	HANDLE m_hThread;	// Xbhnh=XbhIʒm󂯎
	HANDLE m_hStop;		// Xbh~ߔsp

public:
	CMailChecker(CRiffNsm *pNsm, CGID gid, LPCSTR lpURL, LPCSTR lpPassword);
	CMailChecker(CRiffNsm *pNsm, CGID gid, int nAcc, LPCSTR lpPassword);
	~CMailChecker(void);

	void BeginCheck(void)
	{ PostMessage(CMailCheckerThread::WM_USER_BEGIN_CHECK); }
	void EndCheck(void)
	{ PostMessage(CMailCheckerThread::WM_USER_END_CHECK); }
	void CheckNow(void)
	{ PostMessage(CMailCheckerThread::WM_USER_CHECK_NOW); }
	void ConfigChanged(int nAcc)
	{ PostMessage(CMailCheckerThread::WM_USER_CONFIG_UPDATED, 0, nAcc); }
	void OpenSetting(HNsmConnection hConnection)
	{ PostMessage(CMailCheckerThread::WM_USER_OPEN_SETTING, 0, hConnection); }
	void DeleteMail(UINT gid, HWND hParent=NULL)
	{ PostMessage(CMailCheckerThread::WM_USER_DELETE_MAIL, (WPARAM)hParent, gid); }
	void ViewMail(UINT gid)
	{ PostMessage(CMailCheckerThread::WM_USER_VIEW_MAIL, 0,  gid); }
	void RunMUA()
	{ PostMessage(CMailCheckerThread::WM_USER_RUN_MUA); }

private:
	void CreateWorkThread(ThreadParam &p);
	void PostMessage(UINT msg, WPARAM wParam=0, LPARAM lParam=0)
	{
		_ASSERT(m_threadID != NULL);
		::PostThreadMessage(m_threadID, msg, wParam, lParam);
	}

private:
	static RE_PROTOCOL SetServerInfoFromURL(ServerInfo &info, LPCTSTR lpURL);
	static void CreateMsgQueue();
	static void LoadAccSettings(AccSettings &acc, int nAcc, LPCSTR lpURL, LPCSTR lpPassword);
	static unsigned __stdcall RiffThread(void* param);
};
