#pragma once
#pragma warning( disable: 4702 )
	#include <map>
#pragma warning( default: 4702 )
#include <string>
#include "RiffNsmProx.h"
#include "MailServer.h"
#include "Pop3Server.h"
#include "Imap4Server.h"
#include "MailManager.h"
#include "setting_struct.h"
#include "mail_info.h"

class CMailCheckerThread
{
public:
	enum
	{
		WM_USER_EXIT = WM_USER+1,
		WM_USER_CHECK_NOW,
		WM_USER_CONFIG_UPDATED,
		WM_USER_OPEN_SETTING,
		WM_USER_DELETE_MAIL,
		WM_USER_VIEW_MAIL,
		WM_USER_RUN_MUA,
		WM_USER_BEGIN_CHECK,
		WM_USER_END_CHECK,
	};

private:
	CRiffNsmProx m_nsm;
	UINT_PTR m_timerID;
	CMailManager m_mm;
	CheckerSettings m_set;
	CMailServer * const m_pServer;
	int m_nAcc;
	bool m_bCheckMail;
	bool m_bKeepConnection;

public:
	CMailCheckerThread(CRiffNsm *pNsm, CGID gid, AccSettings &set, int nAcc, HANDLE hStop);
	const CMailCheckerThread& operator =(const CMailCheckerThread&)
	{ _ASSERT(FALSE); }
	~CMailCheckerThread(void);
	void RiffThreadBody();

private:
	void DoBeginCheck(void);
	void DoEndCheck(void);
	void DoCheckNow(void);
	void DoConfigChanged(int nAcc);
	void DoOpenSetting(HNsmConnection hConnection);
	void DoDeleteMail(CGID gid, HWND hParent);
	void DoViewMail(CGID gid);
	void DoRunMUA();

	bool GetMailDiffs(NumberMap &add, GIDList &del);
	void Init();
	void BeginTimer();
	void EndTimer();
	void UIMailSync();
	CMailServer* CreateServer(RE_PROTOCOL p, ServerInfo &info, CRiffNsm *pNsm, HANDLE hStop)
	{
		switch( p ){
		case RP_POP3: return new CPop3Server(info, pNsm, hStop);
		case RP_IMAP4: return new CImap4Server(info, pNsm, hStop);
		default: _ASSERT(FALSE); return NULL;
		}
	}
};
