#pragma once
#include <string>
#include <time.h>
#include "Base64Filter.h"
#include "gid.h"

class CMailInfo
{
private:
	CGID m_gid;
	char m_gids[CGID::GIDS_LEN+1];
	time_t m_recv_time;
	std::string m_uid;
	std::string m_subject;
	std::string m_from;
	std::string m_to;
	time_t m_date;
	int m_tz;
	bool m_previewed;

public:
	CMailInfo(CGID gid);
	CMailInfo(CGID gid, LPCSTR uid, time_t t)
	: m_gid(gid), m_uid(uid), m_recv_time(t)
	{
		Init();
	}
	~CMailInfo(void);

	void SetFromHeader(LPCSTR header);
	void ExtractHeaderItem(LPCSTR in_header, LPCSTR in_name, std::string &out_item) const;

	void operator <<(std::ifstream &f);
	void operator >>(std::ofstream &f) const;

	LPCSTR dateStr() const;
	bool SetPreviewed()
	{
		bool pre_state = m_previewed;
		m_previewed = true;
		return pre_state;
	}

private:
	void SetDateFromStr(LPCSTR str);
	int NextNumber(LPCSTR &str);
	bool is_atoi_chr(char c)
	{ return (isdigit(c) || (c == '-') || (c == '+')); }
	void Init()
	{
		m_date = -1;
		m_tz = 0;
		m_previewed = false;
		m_gid.ToStr(m_gids);
	}

public:
	time_t recv_time() const
	{ return m_recv_time; }
	u_int gid() const
	{ return m_gid.gid(); }
	LPCSTR gids() const
	{ return m_gids; }
	LPCSTR uid() const
	{ return m_uid.c_str(); }
	LPCSTR subject() const
	{ return m_subject.c_str(); }
	LPCSTR from() const
	{ return m_from.c_str(); }
	LPCSTR to() const
	{ return m_to.c_str(); }
	bool isPreviewed() const
	{ return m_previewed; }
};
