#include "StdAfx.h"
#include <fstream>
#include <time.h>
#include ".\mailmanager.h"
#include "RiffSettings.h"
#include "mleak.h"

//******************************************************************
// 
//******************************************************************

CMailManager::CMailManager(CGID gid, LPCSTR lpAcc)
: m_gid_filename(RIFF_SETTINGS.GetMyDir() + lpAcc + ".uid")
, m_mid(0xFFFF)
, m_gid(gid)
{
	LoadMails();
}

CMailManager::~CMailManager(void)
{
	MailMap::iterator i;

	for( i = m_mails.begin(); i != m_mails.end(); ++i ){
		delete i->second;
	}
}

//******************************************************************
// 
//******************************************************************

void CMailManager::ExtractMailDiff(const MailIDMap &ids,
		NumberMap &add, GIDList &del)
{
	typedef std::map<int, LPCSTR> NoToUIDMap;
	NoToUIDMap n2u;
	NoToUIDMap::const_iterator no;
	MailMap::const_iterator mail;
	MailIDMap::const_iterator id;
	time_t current_time;

	time(&current_time);

	// 폜ꂽ[𒊏o
	for( mail = m_mails.begin(); mail != m_mails.end(); ++mail ){
		if( ids.find(mail->first) == ids.end() ){
			del.push_back(mail->second->gid());
		}
	}

	// ǉꂽ[𒊏o
	for( id = ids.begin(); id != ids.end(); ++id ){
		if( m_mails.find(id->first.c_str()) == m_mails.end() ){
			n2u[id->second] = id->first.c_str();
		}
	}

	// ǉꂽ[̃[IuWFNg쐬
	for( no = n2u.begin(); no != n2u.end(); ++no ){
		add[no->first] = new CMailInfo(GetNextMailID(), no->second, current_time);
	}
}

void CMailManager::SaveMails() const
{
//	NumberMap::const_iterator i;
	NumberMap::const_reverse_iterator i;
	std::ofstream f(m_gid_filename.c_str());
	if( f.fail() ) return;

	for( i = m_n2m.rbegin(); i != m_n2m.rend(); ++i ){
//	for( i = m_n2m.begin(); i != m_n2m.end(); ++i ){
		*(i->second) >> f;
	}
}

void CMailManager::Delete(const CGID gid)
{
	MailMap::iterator mi;
	NumberMap::iterator ni = m_n2m.find(gid.mail_id());

	if( ni != m_n2m.end() ){
		m_mails.erase(ni->second->uid());
		delete ni->second;
		m_n2m.erase(ni);
	}
}

void CMailManager::Add(NumberMap &list)
{
	NumberMap::iterator i;

	for( i = list.begin(); i != list.end(); ++i ){
		Add(i->second);
	}
}

//******************************************************************
// 
//******************************************************************

void CMailManager::LoadMails()
{
	std::ifstream f(m_gid_filename.c_str());
	CMailInfo *pmi;

	if( f.fail() ) return;

	while( ! f.eof() ){
		pmi = new CMailInfo(GetNextMailID());

		*pmi << f;

		if( f.fail() ){
			delete pmi;
			return;
		}
		Add(pmi);
	}
}
