#pragma once
#pragma warning( disable: 4702 )
	#include <map>
	#include <vector>
#pragma warning( default: 4702 )
#include <utility>
#include "mail_info.h"

//********************************************************


//********************************************************

class CMailManager
{
private:
	std::string m_gid_filename;
	MailMap m_mails;
	NumberMap m_n2m;
	u_short m_mid;
	CGID m_gid;

public:
	CMailManager(CGID gid, LPCSTR lpAcc);
	~CMailManager(void);
	void ExtractMailDiff(const MailIDMap &ids,
		NumberMap &add, GIDList &del);
	void SaveMails() const;
	void Delete(const CGID gid);
	void Add(NumberMap &list);

	const NumberMap& GetNumberMap() const
	{ return m_n2m; }
	CMailInfo* operator[](CGID gid)
	{
		NumberMap::iterator i = m_n2m.find(gid.mail_id());
		return (i != m_n2m.end()) ? i->second: NULL;
	}

private:
	void LoadMails();
	void UnloadMails();
	void Add(CMailInfo *pmi)
	{
		_ASSERT( m_mails.find(pmi->uid()) == m_mails.end() );
		_ASSERT( m_n2m.find(((CGID)pmi->gid()).mail_id()) == m_n2m.end() );
		m_mails[pmi->uid()] = pmi;
		m_n2m[((CGID)pmi->gid()).mail_id()] = pmi;
	}
	CGID GetNextMailID()
	{
		u_int gid = MK_GID(m_gid.conn_id(), m_gid.chkr_id(), m_mid);
//		m_mid++;
		--m_mid;
		return gid;
	}
};
