#pragma once
#include <string>
#include "setting_struct.h"

const char ERR_DISCONNECTED[] = "T[oɐؒf܂";

class CMailServerSocket
{
private:
	enum{
		EVENT_STOP,
		EVENT_SOCKET,
		NUM_OF_EVENTS
	};
	enum{ INTERNAL_BUFFER_SIZE=1024 };

private:
	SOCKET m_socket;
	HANDLE m_hEvents[NUM_OF_EVENTS];
	char m_buf[INTERNAL_BUFFER_SIZE];
	int m_buf_filled;
	int m_timeout;
	RE_SECURITY m_security;
	SSL* m_ssl;
	SSL_CTX* m_ssl_ctx;

public:
	CMailServerSocket(HANDLE hStop, int timeout, RE_SECURITY security);
	~CMailServerSocket(void);

public:
	void Connect(sockaddr_in &saddr);
	void Disconnect();
	void SendString(LPCSTR str);
	void RecvLine(std::string &line);
	void Send(LPCSTR buf, int len);
	int Recv(LPSTR buf, int len);
	int Recv(LPSTR buf, int len, char c);

	void SSLConnect();
	void SSLDisconnect();
	void SSLShutdown();
	void SSLWaitAsyncSocket(int ret);

	bool IsConnected() const
	{ return m_socket != INVALID_SOCKET; }
	bool IsSSL() const
	{ return m_ssl != NULL; }
	void SetTimeout(int timeout)
	{ m_timeout = timeout; }
	void SetSecurity(RE_SECURITY security)
	{ m_security = security; }

private:
	int RecvInternal(void* buf, int len);
	int ReadFromBuffer(void* buf, int len);
	void SaveToBuffer(const void* buf, int len);
	int WaitAsyncSocket(int evt);
};
