#include "StdAfx.h"
#include ".\multipage.h"
#include "resource.h"
#include "NewDlg.h"
#include "MultiSetDlg.h"
#include "general_strings.h"

const static LPCSTR PAGE_TITLE			= "}`AJEg";
const static LPCSTR HEADER_ACCOUNT		= "AJEg";
const static LPCSTR HEADER_ACCOUNTS		= "̃AJEgɊ܂߂VOAJEg";
const static LPCSTR MSG_ACCOUT_EXISTS	= "ɑ݂AJEgł";
const static LPCSTR MSG_TITLE			= "VKAJEg";

//*******************************************************************
// RXgN^EfXgN^
//*******************************************************************
CMultiPage::CMultiPage(const AccountList &list, AccountMap &map)
: m_plist(&list)
, m_pmap(&map)
{
	m_nIDTemplate = IDD_PP_ACCOUNTS;
	m_pTitle = PAGE_TITLE;
}

CMultiPage::~CMultiPage(void)
{
}

//*******************************************************************
// I[o[Ch
//*******************************************************************
BOOL CMultiPage::DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_COMMAND:
		switch(LOWORD(wParam)){

		// ǉ{^
		case IDC_ADD:
			OnClickAdd();
			break;

		// 폜{^
		case IDC_DEL:
			OnClickDelete();
			break;

		// ύX{^
		case IDC_MOD:
			OnClickModify();
			break;

		default:
			return FALSE;
		}
		return TRUE;

	case WM_NOTIFY:
		if( LOWORD(wParam) == IDC_LIST ){
			switch( ((LPNMHDR)lParam)->code ){
			case NM_DBLCLK:
				OnListDblClick();
				break;

			default:
				return FALSE;
			}
			return TRUE;
		}
	}
	return FALSE;
}

BOOL CMultiPage::InitDlgCtrl()
{
	LVCOLUMN lvc;
	HWND hItem;

	// Xg
	hItem = GetDlgItem(IDC_LIST);
	ListView_SetExtendedListViewStyle(hItem, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_LABELTIP);

	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_SUBITEM | LVCF_TEXT;
	lvc.fmt = LVCFMT_LEFT;
	lvc.pszText = (LPSTR)HEADER_ACCOUNT;
	lvc.cx = 80;
	lvc.iSubItem = COL_ACCOUNT;
	ListView_InsertColumn(hItem, COL_ACCOUNT, &lvc);

	lvc.pszText = (LPSTR)HEADER_ACCOUNTS;
	lvc.cx = 320;
	lvc.iSubItem = COL_ACCOUNTS;
	ListView_InsertColumn(hItem, COL_ACCOUNTS, &lvc);

	return TRUE;
}

void CMultiPage::UpdateDlgCtrl()
{
	UpdateList();
}

//*******************************************************************
// Cxgnh
//*******************************************************************
void CMultiPage::OnClickAdd()
{
	// VKAJEg
	CNewDlg ndlg;

	for(;;){
		if( ndlg.DoModal(m_hInstance, m_hDlgWnd) != IDOK ) return;
		if( m_pmap->find(ndlg.GetAccountName()) == m_pmap->end() ) break;
		::MessageBox(m_hDlgWnd, MSG_ACCOUT_EXISTS,
			MSG_TITLE, MB_OK|MB_ICONWARNING|MB_APPLMODAL);
	}


	// VKݒ
	AccNoList *noList = new AccNoList;
	CMultiSetDlg dlg(ndlg.GetAccountName(), *m_plist, *noList);
	if( dlg.DoModal(m_hInstance, m_hDlgWnd) == IDOK ){
		dlg.GetAccNoList(*noList);
		if( noList->size() > 0 ){
			if( m_pmap->insert(std::make_pair(ndlg.GetAccountName(), noList)).second ){
                UpdateList();
				return;
			}
		}
	}

	delete noList;
}

void CMultiPage::OnClickDelete()
{
	HWND hList = GetDlgItem(IDC_LIST);
	INT iSelected = ListView_GetSelectionMark(hList);
	AccountMap::iterator i;
	
	if( (0 <= iSelected) && (iSelected < (int)m_i2acc.size()) ){
		std::string &acc = m_i2acc[iSelected];

		i = m_pmap->find(acc);
		if( i != m_pmap->end() ){
			delete i->second;
			m_pmap->erase(i);

			UpdateList();
			if( iSelected > 0 ){
				ListView_SetItemState(hList, iSelected-1, LVIS_SELECTED, LVIS_SELECTED);
				ListView_SetSelectionMark(hList, iSelected-1);
			}
		}
	}
}

void CMultiPage::OpenSettingDialog()
{
	HWND hList = GetDlgItem(IDC_LIST);
	INT iSelected = ListView_GetSelectionMark(hList);
	AccountMap::iterator i;

	if( (0 <= iSelected) && (iSelected < (int)m_i2acc.size()) ){
		std::string &acc = m_i2acc[iSelected];

		i = m_pmap->find(acc);
		if( i != m_pmap->end() ){
			CMultiSetDlg dlg(acc.c_str(), *m_plist, *(i->second));
			if( dlg.DoModal(m_hInstance, m_hDlgWnd) == IDOK ){
				dlg.GetAccNoList(*(i->second));
				UpdateList();
			}
		}
	}
}

//*******************************************************************
// ̑
//*******************************************************************
void CMultiPage::UpdateList()
{
	int iItem;
	HWND hList;
	LVITEM lvi;
	std::string accs;

	hList = GetDlgItem(IDC_LIST);
	::SendMessage(hList, LVM_DELETEALLITEMS, 0, 0);
	m_i2acc.clear();

	iItem = 0;
	lvi.mask = LVIF_TEXT;
	for( AccountMap::const_iterator i = m_pmap->begin(); i != m_pmap->end(); ++i ){
		const std::string &acc = i->first;
		const AccNoList &noList = *(i->second);

		if( noList[0] != ACCNO_SINGLE ){
			lvi.iItem = iItem;
			lvi.iSubItem = COL_ACCOUNT;
			lvi.pszText = (LPSTR)acc.c_str();
			ListView_InsertItem(hList, &lvi);

			MakeAccListStr(noList, accs);
			ListView_SetItemText(hList, iItem, COL_ACCOUNTS, (LPSTR)accs.c_str());
			iItem++;

			m_i2acc.push_back(acc);
		}
	}
}

void CMultiPage::MakeAccListStr(const AccNoList &list, std::string &out) const
{
	AccNoList::const_iterator i;
	AccountList::const_iterator acc;

	out = NULL_STRING;
	for( i = list.begin(); i != list.end(); ++i ){
		acc = m_plist->find(*i);
		if( acc != m_plist->end() ){
			out += acc->second->account;
			out += ", ";
		}
	}
	if( out.size() > 2 ) out.resize(out.size() - 2);
}
