#include "StdAfx.h"
#include ".\multisetdlg.h"
#include "resource.h"

//*******************************************************************
// RXgN^EfXgN^
//*******************************************************************
CMultiSetDlg::CMultiSetDlg(LPCSTR acc, const AccountList &list, AccNoList &noList)
: CDlg(IDD_MULTISET)
, m_acc(acc)
, m_plist(&list)
, m_noList(noList)
{
}

CMultiSetDlg::~CMultiSetDlg(void)
{
}

//*******************************************************************
// I[o[Ch
//*******************************************************************
BOOL CMultiSetDlg::DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_NOTIFY:
		if( LOWORD(wParam) == IDC_ENABLES ){
			switch( ((LPNMHDR)lParam)->code ){
			case NM_CLICK:
				OnListClick();
				break;
			default:
				return FALSE;
			}
			return TRUE;
		}
	}
	return FALSE;
}

BOOL CMultiSetDlg::InitDlgCtrl()
{
	LVCOLUMN lvc;
	HWND hItem;
	std::string title;

	title = "u";
	title += m_acc;
	title += "vݒ_CAO";
	::SetWindowText(m_hDlgWnd, title.c_str());

	// Xg
	hItem = GetDlgItem(IDC_ENABLES);
	ListView_SetExtendedListViewStyle(hItem,
		LVS_EX_FULLROWSELECT|LVS_EX_CHECKBOXES|LVS_EX_LABELTIP);

	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_SUBITEM;
	lvc.fmt = LVCFMT_LEFT;
	lvc.cx = 220;
	lvc.iSubItem = COL_ACCOUNT;
	ListView_InsertColumn(hItem, COL_ACCOUNT, &lvc);

	UpdateList();
	return TRUE;
}

BOOL CMultiSetDlg::GetDlgCtrlValue()
{
	const HWND hItem = GetDlgItem(IDC_ENABLES);
	const int nItem = ListView_GetItemCount(hItem);
	LVITEM item;

	item.mask = (LVIF_PARAM|LVIF_STATE);
	item.iSubItem = 0;
	item.stateMask = LVIS_STATEIMAGEMASK;

	m_noList.clear();
	for( int i = 0; i < nItem; i++ ){
		item.iItem = i;
		if( ListView_GetItem(hItem, &item) ){
			if( item.state & 0x2000 ){
				m_noList.push_back(item.lParam);
			}
		}
	}

	return TRUE;
}

//*******************************************************************
// Cxgnh
//*******************************************************************
void CMultiSetDlg::OnListClick()
{
	HWND hList = GetDlgItem(IDC_ENABLES);
	INT iSelected = ListView_GetSelectionMark(hList);
	BOOL bSelected;

	if( iSelected >= 0 ){
		bSelected = ListView_GetCheckState(hList, iSelected);
		ListView_SetCheckState(hList, iSelected, !bSelected);
	}
}

//*******************************************************************
// ̑
//*******************************************************************
void CMultiSetDlg::UpdateList() const
{
	int iItem;
	HWND hList;
	LVITEM lvi;
	AccNoMap no2i;
	AccNoMap::iterator no;

	hList = GetDlgItem(IDC_ENABLES);
	::SendMessage(hList, LVM_DELETEALLITEMS, 0, 0);

	iItem = 0;
	lvi.mask = LVIF_TEXT | LVIF_PARAM;
	for( AccountList::const_iterator i = m_plist->begin(); i != m_plist->end(); ++i ){
		lvi.iItem = iItem;
		lvi.iSubItem = COL_ACCOUNT;
		lvi.pszText = (LPSTR)i->second->account.c_str();
		lvi.lParam = i->first;
		ListView_InsertItem(hList, &lvi);

		no2i[i->first] = iItem;
		iItem++;
	}

	for( AccNoList::const_iterator i = m_noList.begin(); i != m_noList.end(); ++i ){
		no = no2i.find(*i);
		if( no != no2i.end() )
			ListView_SetCheckState(hList, no->second, TRUE);
	}
}

