#pragma once
#pragma warning( disable: 4702 )
	#include <map>
#pragma warning( default: 4702 )
#include "mailserver.h"
#include "server_info.h"
#include <string>

class CPop3Server :
	public CMailServer
{
private:
	enum
	{
		AUTO,
		TEXT,
		APOP,
		AUTH_NUM,
	};
	enum{ RES_MAX_LEN=512 };
	enum{ CMD_MAX_LEN=255 };
	const static char AUTH_TYPE_NAME[AUTH_NUM][5];
	struct ThreadParam
	{
		CPop3Server *pThis;
		NumberMap *mails;
	};

public:
	CPop3Server(ServerInfo &info, CComLog *pcl, HANDLE hStop);
	const CPop3Server& operator =(const CPop3Server&)
	{ _ASSERT(FALSE); }
	~CPop3Server(void);

public:
	virtual void GetUIDList(MailIDMap &map);
	void GetMail(LPCSTR uid, std::string &mail, int linenum);
	void DeleteMail(LPCSTR uid);
	void GetMailHeaders(NumberMap &mails);

	u_short GetDefaultPort(RE_SECURITY security)
	{ return (security == RS_SSL) ? POP3S_PORT: POP3_PORT; }
	static int GetNumOfAuthType()
	{ return AUTH_NUM; }
	static LPCSTR GetAuthTypeName(int no)
	{ return AUTH_TYPE_NAME[no]; }

protected:
	void Authorize();
	void Quit();

private:
	bool IsGoodResponce(LPCSTR msg);
	bool CheckRes();
	void AuthText();
	void AuthApop(LPCSTR greeting);
	void AuthAuto(LPCSTR greeting);
//	void AuthAuth();
	int GetNumOfMail();

	int UIDtoMailNo(LPCSTR uid);
	void GetUIDMap(MailIDMap &map);

	unsigned AsyncThreadBody(const NumberMap &mails);

private:
	static unsigned __stdcall CPop3Server::AsyncGetMailHeader(void *param);
};
