#pragma once
#pragma warning( disable: 4702 )
	#include <vector>
#pragma warning( default: 4702 )
#include <string>
#include "dlg.h"
#include "resource.h"

//*************************************************************

class CPreviewDlg :
	public CDlg
{
private:
	typedef std::vector<std::string> StringList;

private:
	enum{ WM_USER_UPDATE_FONT = WM_USER+1 };
	enum{
		WRAP_BTN_TOP=47,
		MAIL_INFO_LEFT=60,
		MAIL_INFO_HEIGHT=15,
		MAIL_BODY_TOP=WRAP_BTN_TOP+22,
		MAIL_BODY_HMARGIN=1,
	};

private:
	static WNDPROC m_pOriginEdit;
	StringList m_parts;
	std::string m_from;
	std::string m_to;
	std::string m_date;
	std::string m_body;
	std::string m_subject;
	RECT m_rect;			// Create, UpdateWindowRect
	HWND m_hBody;
	bool m_bForceWrap;
	LOGFONT m_lf;
	HFONT m_hFont;
	DWORD m_id;

public:
	CPreviewDlg(void);
	~CPreviewDlg(void);

	void Close()
	{ ::SendMessage(m_hDlgWnd, WM_CLOSE, 0, 0); }
	void UpdateFont(LOGFONT &lf)
	{
		m_lf = lf;
		::SendMessage(m_hDlgWnd, WM_USER_UPDATE_FONT, 0, 0);
	}

// I[o[Ch
private:
	BOOL DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	BOOL GetDlgCtrlValue();
	BOOL InitDlgCtrl();

// ̑
public:
	void Set(DWORD id, LPCSTR subject, LPCSTR from,
		LPCSTR to, LPCSTR date, LPCSTR body)
	{
		m_id		= id;
		m_from		= from;
		m_to		= to;
		m_date		= date;
		m_body		= body;
		m_subject	= subject;
	}

private:
	void OnSize(int nType, int width, int height);
	void OnMove(int x, int y);
	void ChangePart();
	void ToggleWrap();
	void RunMUA();
	void DeleteMail();
	void FontUpdated();
	HWND CreateEditBox(LPCSTR text, bool bForceWrap) const;
	void UpdateWindowRect()
	{
		GetWindowRect(m_hDlgWnd, &m_rect);
	}
	HFONT CreateFont()
	{
		HDC hDC = ::GetDC(m_hDlgWnd);
		m_lf.lfHeight = -MulDiv(m_lf.lfHeight, GetDeviceCaps(hDC, LOGPIXELSY), 72);
		::ReleaseDC(m_hDlgWnd, hDC);
		return ::CreateFontIndirect(&m_lf);
	}
	void AddPartString(LPCSTR str)
	{ ::SendMessage(GetDlgItem(IDC_PART), CB_ADDSTRING, 0, (LPARAM)str); }

	void InitPart();
	void ProcessMultiPart(std::string &boundary);
	void ProcessSinglePart();
	void GetPartBoundary(const std::string &in_body, std::string &out_booundary) const;
	int GetNextPart(LPCSTR &part, const std::string &b) const;
	void ProcessPart(std::string &out_pname, std::string &out_pbody, 
		LPCSTR in_part, int len) const;
	void GetAttName(LPCSTR in_fvalue, std::string &out_fname) const;

private:
	static LRESULT CALLBACK CustomEdit(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
	static bool URLHandling(HWND hWnd);
	static bool IsURLChar(char c);
	static LPCSTR TryOpen(LPCSTR st, LPCSTR schema);
};
