#include "StdAfx.h"
#include ".\riffaccountnsm.h"
#include "util.h"
#include "mleak.h"


//******************************************************************
// 
//******************************************************************

CRiffAccountNsm::CRiffAccountNsm(LPCSTR lpAcc)
: CRiffNsm(lpAcc)
{
	std::wstring wacc;

	::SJIStoUnicode(lpAcc, wacc);
	SetCaption(wacc.c_str());

	InitializeCriticalSection(&m_lock);
	NSM_SERVICE.SetConnectionInfo(m_hCon, NMCI_USER_NAME, lpAcc);
	NSM_SERVICE.SetConnectionInfo(m_hCon, NMCI_CAPTION, lpAcc);
	UpdateCheckState();
	NSM_SERVICE.SetConnectionInfo(m_hCon, NMCI_STATUS, NMCS_CONNECTED);
}

CRiffAccountNsm::~CRiffAccountNsm(void)
{
	DeleteCriticalSection(&m_lock);
}

//******************************************************************
// 
//******************************************************************

void CRiffAccountNsm::UpdateProx(int id, LPCWSTR acc, int mnums[])
{
	MailStatusUpdate(id, acc, mnums, mnums);
	UpdateMark();
}

void CRiffAccountNsm::RegistProx(int id, LPCWSTR acc)
{
	CRiffNsm::RegistProx(id, acc);

	NSM_SERVICE.CreateGroup(m_hCon, GroupIdOf(id), acc);
}

void CRiffAccountNsm::MailStatusUpdate(int id, LPCWSTR acc,
					const int* /*const int old_mnums[]*/, const int new_mnums[]) const
{
	std::wostringstream wbuf;
	int sum = 0;

	for( int i = 0; i < NUM_OF_NUM; i++ ) sum += new_mnums[i];

	wbuf << acc;
	wbuf << L"(" << new_mnums[RM_NEW] << L"/" << new_mnums[RM_RECENT] << L"/" << sum << L")";
	NSM_SERVICE.SetGroupInfo(m_hCon, GroupIdOf(id), NMGI_NAME, wbuf.str().c_str());
}

void CRiffAccountNsm::NotifyState(int id, LPCWSTR acc, LPCSTR msg) const
{
	std::wstring wbuf, wmsg;

	::SJIStoUnicode(msg, wmsg);
	wbuf = acc;
	wbuf += L"(" + wmsg + L")";
	NSM_SERVICE.SetGroupInfo(m_hCon, GroupIdOf(id), NMGI_NAME, wbuf.c_str());
}

//******************************************************************
// 
//******************************************************************

