#pragma once
#include <string>
#include "riffnsm.h"

class CRiffAccountNsm :
	public CRiffNsm
{
private:
	enum{ DEF_SIZE=64 };

private:
	CRITICAL_SECTION m_lock;

public:
	CRiffAccountNsm(LPCSTR lpAcc);
	~CRiffAccountNsm(void);

public:
	virtual void UpdateProx(int id, LPCWSTR acc, int mnums[]);
	virtual void RegistProx(int id, LPCWSTR acc);
	virtual void NotifyState(int id, LPCWSTR acc, LPCSTR msg) const;
	virtual void MailStatusUpdate(int id, LPCWSTR acc,
		const int old_mnums[], const int new_mnums[]) const;

	virtual void ChangeMailStatus(LPCSTR gids, MailStatus s) const
	{
		_ASSERT( RM_NOT_SET <= s && s < NUM_OF_NUM );
//		NSM_SERVICE.SetConnectionMemberInfo(m_hCon, gids, NMMI_STATUSSTRING, MAIL_STATUS[s]);
		NSM_SERVICE.SetConnectionMemberInfo(m_hCon, gids, NMMI_STATUS,
			(s == RM_PREVIEWED) ? NMST_OFFLINE: NMST_ONLINE);
	}
	virtual void NotifyDefaultState(int id, LPCWSTR acc, const int mnums[]) const
	{ MailStatusUpdate(id, acc, NULL, mnums); }

protected:
	virtual void Lock()
	{
		EnterCriticalSection(&m_lock);
	}
	virtual void Unlock()
	{
		LeaveCriticalSection(&m_lock);
	}
	virtual void SetMailStatus(int id, LPCSTR gids) const
	{
		NSM_SERVICE.SetConnectionMemberInfo(m_hCon, gids, NMMI_GROUPID, GroupIdOf(id));
	}

	int GroupIdOf(int id) const
	{ return -1 - id; }
};
