#include "StdAfx.h"
#include <process.h>
#include ".\riffconnection.h"
#include "RiffStatusNsm.h"

//CThreadManager CRiffConnection::m_manager;

//******************************************************************
// 
//******************************************************************

CRiffConnection::CRiffConnection(u_int id, PLoginInfo pli)
: m_checker_num(0)
, m_pNsm(NULL)
, m_checkers(NULL)
{
//	m_manager.Enter();
	if( pli->lpAccount == NULL ){
		NullDefaultConstructor();
		return;
	}

	if( IsURL(pli->lpAccount) ){
		m_pNsm = new CRiffStatusNsm(pli->lpAccount);

		CreateCheckerArray(1);
		m_checkers[0] = new CMailChecker(m_pNsm, MK_GID(id, 0, 0), pli->lpAccount, pli->lpPassword);
	}else{
		AccNoList list;
		AccNoList::iterator i;
		int count;

		RIFF_SETTINGS.GetAccNoList(list, pli->lpAccount);

		if( list.size() <= 0 ){
			NullDefaultConstructor();
			return;
		}
		if( (list.size() == 1) ){
			m_pNsm = new CRiffStatusNsm(pli->lpAccount);
		}else{
			m_pNsm = new CRiffAccountNsm(pli->lpAccount);
		}

		CreateCheckerArray(list.size());
		count = 0;
		for( i = list.begin(); i != list.end(); ++i ){
			m_checkers[count] = new CMailChecker(m_pNsm, MK_GID(id, count, 0), *i, pli->lpPassword);
			count++;
		}
	}

	if( pli->nStatus == NMST_ONLINE )
		BeginCheck();
}

CRiffConnection::~CRiffConnection(void)
{
	for( int i = 0; i < m_checker_num; i++ )
		delete m_checkers[i];
	delete m_checkers;
	delete m_pNsm;
}
/*
//******************************************************************
// 
//******************************************************************

void CRiffConnection::Delete()
{
	_beginthread(DeleteThread, 0, this);
}

//******************************************************************
// 
//******************************************************************

void __cdecl CRiffConnection::DeleteThread(void *param)
{
	delete (CRiffConnection*)param;
	m_manager.Leave();
}
*/
