#pragma once
#include "MailChecker.h"
#include "RiffNsm.h"
#include "RiffAccountNsm.h"
//#include "ThreadManager.h"
#include "gid.h"

//**************************************************************

#define FOREACH_CHECKERS(code) \
	for( int i = 0; i < m_checker_num; i++ ){ \
		m_checkers[i]->code; \
	}

#define CALL_CHECKER(id, func) \
	_ASSERT( (id) < m_checker_num ); \
	m_checkers[(id)]->func;

#define CALL_CHECKER_BY_G(g, func) \
	if( m_checker_num == 1 ){ m_checkers[0]->func; }\
	else{ CALL_CHECKER(-1-(g), func); }

//**************************************************************

class CRiffConnection
{
private:
//	static CThreadManager m_manager;
	CMailChecker** m_checkers;
	CRiffNsm *m_pNsm;
	int m_checker_num;

public:
	CRiffConnection(u_int id, PLoginInfo pli);
	~CRiffConnection(void);

//	void Delete();

	void BeginCheck()
	{ FOREACH_CHECKERS( BeginCheck() ); }
	void BeginCheck(int id)
	{ CALL_CHECKER_BY_G(id, BeginCheck()); }
	void EndCheck()
	{ FOREACH_CHECKERS( EndCheck() ); }
	void EndCheck(int id)
	{ CALL_CHECKER_BY_G(id, EndCheck()); }
	void CheckNow(int id)
	{ CALL_CHECKER_BY_G(id, CheckNow()); }
	void ConfigChanged(int nAcc)
	{ FOREACH_CHECKERS( ConfigChanged(nAcc) ); }
	void OpenSetting(HNsmConnection hConnection, int id)
	{ CALL_CHECKER_BY_G(id, OpenSetting(hConnection)); }
	void DeleteMail(LPCSTR gid)
	{
		CGID n_gid(strtoul(gid, NULL, 16));
		CALL_CHECKER(n_gid.chkr_id(), DeleteMail(n_gid));
	}
	void ViewMail(LPCSTR gid)
	{
		CGID n_gid(strtoul(gid, NULL, 16));
		CALL_CHECKER(n_gid.chkr_id(), ViewMail(n_gid));
	}
	void ViewMail(CGID gid)
	{ CALL_CHECKER(gid.chkr_id(), ViewMail(gid.gid())); }
	void DeleteMail(CGID gid, HWND hParent)
	{ CALL_CHECKER(gid.chkr_id(), DeleteMail(gid.gid(), hParent)); }
	void RunMUA(CGID gid)
	{ CALL_CHECKER(gid.chkr_id(), RunMUA()); }
	void RunMUA(int id)
	{ CALL_CHECKER_BY_G(id, RunMUA()); }

	HNsmConnection GetConnection() const
	{ return m_pNsm->GetConnection(); }

//	static void Cleanup()
//	{ m_manager.Cleanup(); }

private:
	bool IsNULL(LPCSTR lpAcc)
	{
		return (lpAcc == NULL) || (lpAcc[0] == '\0');
	}
	bool IsURL(LPCSTR lpAcc)
	{
		return strstr(lpAcc, "://") != NULL;
	}
	void CreateCheckerArray(int size)
	{
		m_checker_num = size;
		m_checkers = new CMailChecker*[size];
	}
	void NullDefaultConstructor()
	{
		m_pNsm = new CRiffAccountNsm(NULL_STRING);
	}

private:
//	static void __cdecl DeleteThread(void *param);
};
