#pragma once

class CRiffException
{
public:
	const int m_last_err;
	const int m_wsa_last_err;
	const unsigned long m_ssl_error;
	LPCSTR m_err_msg;

public:
	CRiffException(LPCSTR msg)
	: m_last_err( ::GetLastError() )
	, m_wsa_last_err( ::WSAGetLastError() )
	, m_ssl_error( ::ERR_get_error() )
	, m_err_msg( msg )
	{
		ERR_clear_error();
	}
	CRiffException(const CRiffException& rhs)
	: m_last_err( rhs.GetLastError() )
	, m_wsa_last_err( rhs.WSAGetLastError() )
	, m_ssl_error( rhs.ERR_get_error() )
	, m_err_msg( rhs.GetErrorMsg() )
	{
	}
	~CRiffException(void)
	{
	}

	int GetLastError() const
	{ return m_last_err; }
	int WSAGetLastError() const
	{ return m_wsa_last_err; }
	unsigned long ERR_get_error() const
	{ return m_ssl_error; }
	LPCSTR GetErrorMsg() const
	{ return m_err_msg; }
	void ReplaceErrorMsg(LPCSTR msg)
	{ m_err_msg = msg; }

private:
	CRiffException& operator=(CRiffException&);
};
