#include "StdAfx.h"
#include <time.h>
#include ".\riffglobal.h"

CRiffGlobal CRiffGlobal::m_singleton;

//******************************************************************
// 
//******************************************************************

CRiffGlobal::CRiffGlobal(void)
: m_max_notify(0)
{
	InitializeCriticalSection(&m_lock);
}

CRiffGlobal::~CRiffGlobal(void)
{
	DeleteCriticalSection(&m_lock);
}

//******************************************************************
// public
//******************************************************************

// ʒmp
bool CRiffGlobal::IsOverNotifyNum(bool bForce, int term)
{
	time_t now;

	time(&now);
	
	// L[玞ԉẑ̂菜
	while( (m_notify_q.size() > 0) && (m_notify_q.top() < now) )
		m_notify_q.pop();

	// L[ςȂʒm
	if( ! bForce ){
		if( (m_max_notify > 0) && (m_notify_q.size() >= (u_int)m_max_notify) )
			return true;
	}

	// L[ɓo^
	m_notify_q.push(now + term);
	
	return false;
}

// vr[EChEǗp
void CRiffGlobal::RegistPrevDlg(CPreviewDlg *pd)
{
	Lock();
	m_pdList.push_back(pd);
	Unlock();
}

// vr[EChEǗp
void CRiffGlobal::UnregistPrevDlg(CPreviewDlg *pd)
{
	PrevDlgList::iterator i;

	Lock();
	i = std::find(m_pdList.begin(), m_pdList.end(), pd);
	if( i != m_pdList.end() )
		m_pdList.erase(i);
	Unlock();
}

// vr[EChEǗp
void CRiffGlobal::DeleteAll()
{
	PrevDlgList::iterator i;

	Lock();
	for( i = m_pdList.begin(); i != m_pdList.end(); i++ ){
		(*i)->Close();
	}
	Unlock();
}

// vr[EChEǗp
void CRiffGlobal::FontUpdated(LOGFONT &lf)
{
	PrevDlgList::iterator i;

	Lock();
	for( i = m_pdList.begin(); i != m_pdList.end(); i++ ){
		(*i)->UpdateFont(lf);
	}
	Unlock();
}

//******************************************************************
// private
//******************************************************************
