#pragma once
#pragma warning( disable: 4702 )
	#include <vector>
	#include <queue>
#pragma warning( default: 4702 )
#include <functional>
#include "PreviewDlg.h"

#define RIFF_GLOBAL (CRiffGlobal::GetInstance())

class CRiffGlobal
{
// singleton -->
private:
	static CRiffGlobal m_singleton;

public:
	static CRiffGlobal& GetInstance()
	{ return m_singleton; }

private:
	CRiffGlobal(void);
	~CRiffGlobal(void);
// <-- singleton

private:
	typedef std::vector<CPreviewDlg*> PrevDlgList;
	typedef std::priority_queue<time_t, std::vector<time_t>,
		std::greater<time_t> > TimeList;

private:
	CRITICAL_SECTION m_lock;
	PrevDlgList m_pdList;
	TimeList m_notify_q;
	int m_max_notify;

public:
	void SetMaxNotify(int max)
	{ m_max_notify = max; }
	bool IsOverNotifyNum(bool bForce, int time);
	void RegistPrevDlg(CPreviewDlg *pd);
	void UnregistPrevDlg(CPreviewDlg *pd);
	void DeleteAll();
	void FontUpdated(LOGFONT &lf);

private:
	void Lock()
	{ EnterCriticalSection(&m_lock); }
	void Unlock()
	{ LeaveCriticalSection(&m_lock); }
};
