#pragma once
#include "nsmplugin.h"
#include "ConList.h"

class CRiffPlugin :
	public CNsmPlugin
{
// Singleton -->
private:
	static CRiffPlugin m_singleton;

private:
	CRiffPlugin(void);
public:
	~CRiffPlugin(void);

public:
	static CRiffPlugin& GetInstance()
	{
		return m_singleton;
	}
// <-- Singleton

// T[rXƃtbN
public:
	DEFINE_SERVICE1(ShowOptionDialog, HWND);

	DEFINE_SERVICE1(ConConnect, PLoginInfo);
	DEFINE_SERVICE1(ConDisconnect, HNsmConnection);
	DEFINE_SERVICE2(ConChangeUserStatus, HNsmConnection, PUserStatusInfo);
//	DEFINE_SERVICE2(ConRemoveMember, HNsmConnection, PRemoveMemberInfo);
	DEFINE_SERVICE2(SesOpen, HNsmConnection, POpenSessionInfo);

	DEFINE_SERVICE2(MailPreview, HNsmConnection, PNsmUIServiceInfo);
	DEFINE_SERVICE2(MailDelete, HNsmConnection, PNsmUIServiceInfo);
	DEFINE_SERVICE2(OpenSetting, HNsmConnection, PNsmUIServiceInfo);
	DEFINE_SERVICE2(CheckNow, HNsmConnection, PNsmUIServiceInfo);
	DEFINE_SERVICE2(ToggleCheck, HNsmConnection, PNsmUIServiceInfo);
	DEFINE_SERVICE2(BeginCheck, HNsmConnection, PNsmUIServiceInfo);
	DEFINE_SERVICE2(EndCheck, HNsmConnection, PNsmUIServiceInfo);
	DEFINE_SERVICE2(GRunMUA, HNsmConnection, PNsmUIServiceInfo);

	DEFINE_SERVICE2(ConfigUpdated, HNsmConnection, int);
	DEFINE_SERVICE1(PreviewMail, UINT);
	DEFINE_SERVICE2(DeleteMail, UINT, HWND);
	DEFINE_SERVICE1(RunMUA, UINT);

private:
	int DoShowOptionDialog(HWND hWnd);

	int DoConConnect(PLoginInfo pli);
	int DoConDisconnect(HNsmConnection hConnection);
	int DoConChangeUserStatus(HNsmConnection hConnection, PUserStatusInfo pusi);
//	int DoConRemoveMember(HNsmConnection hConnection, PRemoveMemberInfo prmi);
	int DoSesOpen(HNsmConnection hConnection, POpenSessionInfo posi);

	int DoMailPreview(HNsmConnection hConnection, PNsmUIServiceInfo pnuis);
	int DoMailDelete(HNsmConnection hConnection, PNsmUIServiceInfo pnuis);
	int DoOpenSetting(HNsmConnection hConnection, PNsmUIServiceInfo pnuis);
	int DoCheckNow(HNsmConnection hConnection, PNsmUIServiceInfo pnuis);
	int DoToggleCheck(HNsmConnection hConnection, PNsmUIServiceInfo pnuis);
	int DoBeginCheck(HNsmConnection hConnection, PNsmUIServiceInfo pnuis);
	int DoEndCheck(HNsmConnection hConnection, PNsmUIServiceInfo pnuis);
	int DoGRunMUA(HNsmConnection hConnection, PNsmUIServiceInfo pnuis);

	int DoConfigUpdated(HNsmConnection hConnection, int nAcc);
	int DoPreviewMail(UINT gid);
	int DoDeleteMail(UINT gid, HWND hParent);
	int DoRunMUA(UINT gid);

// I[o[Ch
public:
	int OnInitialize();
	void OnTerminate();
	int OnSystemModulesLoaded();

// ̑
private:
	bool m_bWSAStartupSuccess;
	CConList m_cons;
};
