#include "StdAfx.h"
#include ".\riffstatusnsm.h"
#include "mleak.h"

//******************************************************************
// 
//******************************************************************

CRiffStatusNsm::CRiffStatusNsm(LPCSTR lpAcc)
: CRiffNsm(lpAcc)
{
}

CRiffStatusNsm::~CRiffStatusNsm(void)
{
}

//******************************************************************
// 
//******************************************************************

void CRiffStatusNsm::UpdateProx(int /*id*/, LPCWSTR acc, int* /*int mnums[]*/)
{
	NSM_SERVICE.SetConnectionInfo(m_hCon, NMCI_USER_NAME, acc);
	UpdateMark();
}

void CRiffStatusNsm::RegistProx(int id, LPCWSTR acc)
{
	CRiffNsm::RegistProx(id, acc);

	NSM_SERVICE.SetConnectionInfo(m_hCon, NMCI_USER_NAME, acc);
	SetCaption(acc);
	for( int i = RM_NOT_SET + 1; i < NUM_OF_NUM; i++ )
		NSM_SERVICE.CreateGroup(m_hCon, GroupIdOf((MailStatus)i), MAIL_STATUS[i]);
	UpdateCheckState();
	NSM_SERVICE.SetConnectionInfo(m_hCon, NMCI_STATUS, NMCS_CONNECTED);
}

void CRiffStatusNsm::MailStatusUpdate(int /*id*/, LPCWSTR /*acc*/,
		const int old_mnums[], const int new_mnums[]) const
{
	wchar_t buf[DEF_SIZE];
	int oldsum = 0, newsum = 0;

	for( int i = 0; i < NUM_OF_NUM; i++ ){
		oldsum += old_mnums[i];
		newsum += new_mnums[i];
	}

	for( int i = RM_NOT_SET + 1; i < NUM_OF_NUM; i++ ){
		if( (oldsum != newsum) || (old_mnums[i] != new_mnums[i]) ){
			swprintf_s(buf, L"%s %d / %d", MAIL_STATUS[i], new_mnums[i], newsum);
			NSM_SERVICE.SetGroupInfo(m_hCon, GroupIdOf((MailStatus)i), NMGI_NAME, buf);
		}
	}
}

