#pragma once
#include "riffnsm.h"

class CRiffStatusNsm :
	public CRiffNsm
{
private:
	enum MailGroup
	{
		RG_NORMAL= - RM_NORMAL,
		RG_RECENT= - RM_RECENT,
		RG_NEW= - RM_NEW,
		RG_PREVIEWED= - RM_PREVIEWED,
	};
	enum{ DEF_SIZE=64 };

private:

public:
	CRiffStatusNsm(LPCSTR lpAcc);
	~CRiffStatusNsm(void);

public:
	virtual void UpdateProx(int id, LPCWSTR acc, int mnums[]);
	virtual void RegistProx(int id, LPCWSTR acc);
	virtual void MailStatusUpdate(int id, LPCWSTR acc,
		const int old_mnums[], const int new_mnums[]) const;

	virtual void ChangeMailStatus(LPCSTR gid, MailStatus s) const
	{
		_ASSERT( RM_NOT_SET <= s && s < NUM_OF_NUM );
//		NSM_SERVICE.SetConnectionMemberInfo(m_hCon, gid, NMMI_STATUSSTRING, MAIL_STATUS[s]);
		NSM_SERVICE.SetConnectionMemberInfo(m_hCon, gid, NMMI_GROUPID, GroupIdOf(s));
		NSM_SERVICE.SetConnectionMemberInfo(m_hCon, gid, NMMI_STATUS,
			(s == RM_PREVIEWED) ? NMST_OFFLINE: NMST_ONLINE);
	}
	virtual void NotifyState(int /*id*/, LPCWSTR /*acc*/, LPCSTR msg) const
	{ NSM_SERVICE.SetConnectionInfo(m_hCon, NMCI_USER_STATUSSTRING, msg); }
	virtual void NotifyDefaultState(int /*id*/, LPCWSTR /*acc*/, const int* /*const int mnums[]*/) const
	{ UpdateCheckState(); }

protected:
	virtual void Lock(){};
	virtual void Unlock(){};
	virtual void SetMailStatus(int /*id*/, LPCSTR /*gid*/) const
	{
	}

	int GroupIdOf(MailStatus s) const
	{ return -s; }
};
