#include "StdAfx.h"
#include <process.h>
#include ".\settingdlg.h"
#include "Pop3Server.h"
#include "Imap4Server.h"

//******************************************************************
// 
//******************************************************************
/*
CSettingDlg::CSettingDlg(void)
{
	m_nIDTemplate = IDD_SETTING;
	m_hParentWnd = NULL;
}
*/
CSettingDlg::~CSettingDlg(void)
{
}

//******************************************************************
// 
//******************************************************************

#define USE_DEFAULT(id, b, name) UseDefault(id, b, m_pset->name.value, m_pdef->name)
#define USE_DEFAULTx(id, b, name) UseDefaultx(id, b, m_pset->name.value, m_pdef->name)
BOOL CSettingDlg::DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uMsg ){
	case WM_NOTIFY:
		switch( ((LPNMHDR)lParam)->code ){
		case TTN_GETDISPINFO:
			::SendMessage(((LPNMHDR)lParam)->hwndFrom, TTM_SETMAXTIPWIDTH, 0, 500);
			((LPNMTTDISPINFO)lParam)->lpszText = MAKEINTRESOURCE(((LPNMTTDISPINFO)lParam)->lParam);
			((LPNMTTDISPINFO)lParam)->hinst = m_hInstance;
			break;

		default:
			return FALSE;
		}
		return TRUE;
	case WM_COMMAND:
		switch( LOWORD(wParam) ){
		case IDC_INTERVAL_DEF:		USE_DEFAULT(IDC_INTERVAL, true, interval); break;
		case IDC_NOTIFYTERM_DEF:	USE_DEFAULT(IDC_NOTIFYTERM, true, notify_term); break;
		case IDC_EACH_DEF:			USE_DEFAULT(IDC_EACH, true, notify_each); break;
		case IDC_MAXMAIL_DEF:		USE_DEFAULT(IDC_MAXMAIL, true, max_mail); break;
		case IDC_MAILTERM_DEF:		USE_DEFAULTx(IDC_MAILTERM, true, show_term); break;
		case IDC_PRVW_DEF:			USE_DEFAULT(IDC_PRVW, true, preview_linenum); break;
		case IDC_AUTOPRVW_DEF:		USE_DEFAULT(IDC_AUTOPRVW, true, auto_preview); break;

		case IDC_INTERVAL_USE:		USE_DEFAULT(IDC_INTERVAL, false, interval); break;
		case IDC_NOTIFYTERM_USE:	USE_DEFAULT(IDC_NOTIFYTERM, false, notify_term); break;
		case IDC_EACH_USE:			USE_DEFAULT(IDC_EACH, false, notify_each); break;
		case IDC_MAXMAIL_USE:		USE_DEFAULT(IDC_MAXMAIL, false, max_mail); break;
		case IDC_MAILTERM_USE:		USE_DEFAULTx(IDC_MAILTERM, false, show_term); break;
		case IDC_PRVW_USE:			USE_DEFAULT(IDC_PRVW, false, preview_linenum); break;
		case IDC_AUTOPRVW_USE:		USE_DEFAULT(IDC_AUTOPRVW, false, auto_preview); break;

		case IDC_POP3:
		case IDC_IMAP4:
				UpdateAuthList();
				UpdateKeepCon();
				break;

		case IDC_AUTH:
			if( HIWORD(wParam) == CBN_SELCHANGE )
				UpdateAuthType();

		default:
			return FALSE;
		}
		break;
	default:
		return FALSE;
	}

	return TRUE;
}

#define SET_RADIO(ctr, b)	SetCheck((b) ? ctr##_DEF: ctr##_USE, true);
BOOL CSettingDlg::InitDlgCtrl()
{
	std::string title;

	title = "u" + m_pset->account + "vݒ_CAO";
	::SetWindowText(m_hDlgWnd, title.c_str());
//	SetItemText(IDC_ACCNAME, m_pset->account.c_str());

	SetCheck(IDC_POP3, (m_pset->protocol == RP_POP3));
	SetCheck(IDC_IMAP4, (m_pset->protocol == RP_IMAP4));
	UpdateAuthList();

	switch( m_pset->server.security )
	{
	case RS_SSL:	SetCheck(IDC_SEC_SSL, true);	break;
	case RS_STLS:	SetCheck(IDC_SEC_STLS, true);	break;
	default:		SetCheck(IDC_SEC_NONE, true);	break;
	}

	SetItemText(IDC_HOST, m_pset->server.host.c_str());
	SetItemText(IDC_PORT, m_pset->server.port);
	SetItemText(IDC_ACCOUNT, m_pset->server.user.c_str());
	SetItemText(IDC_PASS, m_pset->server.pass.c_str());
	SetItemText(IDC_MUA_OPTION, m_pset->mua_option.c_str());

//	SetCheck(IDC_USE_ASYNC, m_pset->server.use_async);
//	SetCheck(IDC_KEEP_CON, m_pset->server.keep_con);
	UpdateKeepCon();

	SET_RADIO(IDC_INTERVAL, m_pset->interval.use_default);
	SET_RADIO(IDC_NOTIFYTERM, m_pset->notify_term.use_default);
	SET_RADIO(IDC_EACH, m_pset->notify_each.use_default);
	SET_RADIO(IDC_MAXMAIL, m_pset->max_mail.use_default);
	SET_RADIO(IDC_MAILTERM, m_pset->show_term.use_default);
	SET_RADIO(IDC_PRVW, m_pset->preview_linenum.use_default);
	SET_RADIO(IDC_AUTOPRVW, m_pset->auto_preview.use_default);

	SelectText(IDC_INTERVAL,	m_pset->interval.use_default,		m_pset->interval.value,			m_pdef->interval);
	SelectText(IDC_NOTIFYTERM,	m_pset->notify_term.use_default,	m_pset->notify_term.value,		m_pdef->notify_term);
	SelectCheck(IDC_EACH,		m_pset->notify_each.use_default,	m_pset->notify_each.value,		m_pdef->notify_each);
	SelectText(IDC_MAXMAIL,		m_pset->max_mail.use_default,		m_pset->max_mail.value,			m_pdef->max_mail);
	SelectText(IDC_MAILTERM,	m_pset->show_term.use_default,		m_pset->show_term.value/(60*60),m_pdef->show_term/(60*60));
	SelectText(IDC_PRVW,		m_pset->preview_linenum.use_default,m_pset->preview_linenum.value,	m_pdef->preview_linenum);
	SelectCheck(IDC_AUTOPRVW,	m_pset->auto_preview.use_default,	m_pset->auto_preview.value,		m_pdef->auto_preview);

	int cid = IDC_POP3;
	int sid =IDS_POP3;
	m_tip.Create(m_hInstance, m_hDlgWnd);
	for( ; cid <= IDC_SETTING_CTRL_END; cid++, sid++ ){
		m_tip.AddToolToToolTip(m_hDlgWnd, GetDlgItem(cid), sid);
	}
	m_tip.Begin();

	return TRUE;
}

BOOL CSettingDlg::GetDlgCtrlValue()
{
	int auth;

//	GetEditBoxText(IDC_ACCNAME, m_pset->account);
	m_pset->protocol = (GetCheck(IDC_IMAP4) ? RP_IMAP4: RP_POP3);
	auth = ::SendMessage(GetDlgItem(IDC_AUTH), CB_GETCURSEL, 0, 0);
	if( auth != CB_ERR ) m_pset->server.auth = auth;

	m_pset->server.security = RS_NONE;
	if( GetCheck(IDC_SEC_SSL ) ) m_pset->server.security = RS_SSL;
	if( GetCheck(IDC_SEC_STLS) ) m_pset->server.security = RS_STLS;

	GetItemText(IDC_HOST, m_pset->server.host);
	m_pset->server.port = static_cast<u_short>(GetItemTextInt(IDC_PORT));
	GetItemText(IDC_ACCOUNT, m_pset->server.user);
	GetItemText(IDC_PASS, m_pset->server.pass);
	GetItemText(IDC_MUA_OPTION, m_pset->mua_option);

//	m_pset->server.use_async = GetCheck(IDC_USE_ASYNC);
//	m_pset->server.keep_con  = GetCheck(IDC_KEEP_CON);

	m_pset->interval.use_default = ! GetCheck(IDC_INTERVAL_USE);
	m_pset->notify_term.use_default = ! GetCheck(IDC_NOTIFYTERM_USE);
	m_pset->notify_each.use_default = ! GetCheck(IDC_EACH_USE);
	m_pset->max_mail.use_default = ! GetCheck(IDC_MAXMAIL_USE);
	m_pset->show_term.use_default = ! GetCheck(IDC_MAILTERM_USE);
	m_pset->preview_linenum.use_default = ! GetCheck(IDC_PRVW_USE);
	m_pset->auto_preview.use_default = ! GetCheck(IDC_AUTOPRVW_USE);

	if( ! m_pset->interval.use_default )
		m_pset->interval.value = GetItemTextInt(IDC_INTERVAL);
	if( ! m_pset->notify_term.use_default )
		m_pset->notify_term.value = GetItemTextInt(IDC_NOTIFYTERM);
	if( ! m_pset->notify_each.use_default )
		m_pset->notify_each.value = GetCheck(IDC_EACH);
	if( ! m_pset->max_mail.use_default )
		m_pset->max_mail.value = GetItemTextInt(IDC_MAXMAIL);
	if( ! m_pset->show_term.use_default )
		m_pset->show_term.value = GetItemTextInt(IDC_MAILTERM) * 60 * 60;
	if( ! m_pset->preview_linenum.use_default )
		m_pset->preview_linenum.value = GetItemTextInt(IDC_PRVW);
	if( ! m_pset->auto_preview.use_default )
		m_pset->auto_preview.value = GetCheck(IDC_AUTOPRVW);

	return TRUE;
}

//******************************************************************
// 
//******************************************************************
void CSettingDlg::UpdateAuthList()
{
	HWND hAuthWnd = GetDlgItem(IDC_AUTH);
	int authType;

	::SendMessage(hAuthWnd, CB_RESETCONTENT, 0, 0);

	if( GetCheck(IDC_IMAP4) ){
		authType = m_imap4AuthType;
		for( int i = 0; i < CImap4Server::GetNumOfAuthType(); i++ )
			::SendMessage(hAuthWnd, CB_INSERTSTRING,
				static_cast<WPARAM>(-1), 
				reinterpret_cast<LPARAM>(CImap4Server::GetAuthTypeName(i))
			);
	}else{
		authType = m_pop3AuthType;
		for( int i = 0; i < CPop3Server::GetNumOfAuthType(); i++ )
			::SendMessage(hAuthWnd, CB_INSERTSTRING,
				static_cast<WPARAM>(-1), 
				reinterpret_cast<LPARAM>(CPop3Server::GetAuthTypeName(i))
			);
	}

	::SendMessage(hAuthWnd, CB_SETCURSEL, authType, 0);
}

void CSettingDlg::UpdateAuthType()
{
	if( GetCheck(IDC_IMAP4) ){
		m_imap4AuthType = SendMessage(IDC_AUTH, CB_GETCURSEL);
	}else{
		m_pop3AuthType = SendMessage(IDC_AUTH, CB_GETCURSEL);
	}
}

void CSettingDlg::UpdateKeepCon()
{
//	SetEnable(IDC_KEEP_CON, GetCheck(IDC_IMAP4));
}
