#pragma once
#include <string>
#include "resource.h"
#include "setting_struct.h"
#include "dlg.h"

class CSettingDlg :
	public CDlg
{
private:
	CToolTip m_tip;
	FullSettings *m_pset;
	const DefaultSettings * const m_pdef;
	int m_imap4AuthType;
	int m_pop3AuthType;

public:
	CSettingDlg(FullSettings &f, const DefaultSettings &d)
	: CDlg(IDD_SETTING)
	, m_pset(&f)
	, m_pdef(&d)
	, m_imap4AuthType(0)
	, m_pop3AuthType(0)
	{
		if( f.protocol == RP_IMAP4 )
		{
			m_imap4AuthType = f.server.auth;
		}
		else
		{
			m_pop3AuthType = f.server.auth;
		}
	}
	const CSettingDlg& operator =(const CSettingDlg&)
	{ _ASSERT(FALSE); }
	~CSettingDlg(void);

private:
	void UpdateAuthList();
	void UpdateAuthType();
	void UpdateKeepCon();

	void UseDefault(UINT nID, bool bUse, int &val, int def)
	{
		if( bUse ) val = GetItemTextInt(nID);
		SelectText(nID, bUse, val, def);
	}
	void UseDefaultx(UINT nID, bool bUse, int &val, int def)
	{
		if( bUse ) val = GetItemTextInt(nID) * 60 * 60;
		SelectText(nID, bUse, val/(60*60), def/(60*60));
	}
	void UseDefault(UINT nID, bool bUse, int &val, bool def)
	{
		if( bUse ) val = GetCheck(nID);
		SelectCheck(nID, bUse, val, def);
	}
	void SelectText(UINT nID, bool bUse, int val, int def)
	{
		SetEnable(nID, ! bUse);
		SetItemText(nID, bUse ? def: val);
	}
	void SelectCheck(UINT nID, bool bUse, int val, bool def)
	{
		SetEnable(nID, ! bUse);
		SetCheck(nID, bUse ? def: val);
	}

// I[o[Ch
private:
	BOOL DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam);
	BOOL InitDlgCtrl();
	BOOL GetDlgCtrlValue();
};
