#include "StdAfx.h"
#include <string>
#include <utility>
#include ".\singlepage.h"
#include "resource.h"
#include "Pop3Server.h"
#include "Imap4Server.h"
#include "NewDlg.h"
#include "SettingDlg.h"

const static LPCSTR PAGE_TITLE			= "VOAJEg";
const static LPCSTR HEADER_ACCOUNT		= "AJEg";
const static LPCSTR HEADER_URL			= "[URL";
const static LPCSTR MSG_ACCOUT_EXISTS	= "ɑ݂AJEgł";
const static LPCSTR MSG_TITLE			= "VKAJEg";

//*******************************************************************
// RXgN^EfXgN^
//*******************************************************************
CSinglePage::CSinglePage(AccountList &list, AccountMap &map, const DefaultSettings &def)
: m_plist(&list)
, m_pmap(&map)
, m_pdef(&def)
, m_nextAccNo(0)
{
	AccountList::iterator i;

	m_nIDTemplate = IDD_PP_ACCOUNTS;
	m_pTitle = PAGE_TITLE;

	for( i = m_plist->begin(); i != m_plist->end(); ++i )
		if( i->first > m_nextAccNo ) m_nextAccNo = i->first;
	m_nextAccNo++;
}

CSinglePage::~CSinglePage(void)
{
}

//*******************************************************************
// I[o[Ch
//*******************************************************************
BOOL CSinglePage::DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_COMMAND:
		switch(LOWORD(wParam)){

		// ǉ{^
		case IDC_ADD:
			OnClickAdd();
			break;

		// 폜{^
		case IDC_DEL:
			OnClickDelete();
			break;

		// ύX{^
		case IDC_MOD:
			OnClickModify();
			break;

		default:
			return FALSE;
		}
		return TRUE;

	case WM_NOTIFY:
		if( LOWORD(wParam) == IDC_LIST ){
			switch( ((LPNMHDR)lParam)->code ){
			case NM_DBLCLK:
				OnListDblClick();
				break;

			default:
				return FALSE;
			}
			return TRUE;
		}
	}
	return FALSE;
}

BOOL CSinglePage::InitDlgCtrl()
{
	LVCOLUMN lvc;
	HWND hItem;

	// Xg
	hItem = GetDlgItem(IDC_LIST);
	ListView_SetExtendedListViewStyle(hItem, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_LABELTIP);

	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_SUBITEM | LVCF_TEXT;
	lvc.fmt = LVCFMT_LEFT;
	lvc.pszText = (LPSTR)HEADER_ACCOUNT;
	lvc.cx = 80;
	lvc.iSubItem = COL_ACCOUNT;
	ListView_InsertColumn(hItem, COL_ACCOUNT, &lvc);

	lvc.pszText = (LPSTR)HEADER_URL;
	lvc.cx = 320;
	lvc.iSubItem = COL_URL;
	ListView_InsertColumn(hItem, COL_URL, &lvc);

	UpdateList();
	return TRUE;
}

//*******************************************************************
// Cxgnh
//*******************************************************************
#define RESET_DAV(dav) \
	pset->dav.use_default = true; \
	pset->dav.value = m_pdef->dav;

void CSinglePage::OnClickAdd()
{
	// VKAJEg
	CNewDlg ndlg;

	for(;;){
		if( ndlg.DoModal(m_hInstance, m_hDlgWnd) != IDOK ) return;
		if( m_pmap->find(ndlg.GetAccountName()) == m_pmap->end() ) break;
		::MessageBox(m_hDlgWnd, MSG_ACCOUT_EXISTS,
			MSG_TITLE, MB_OK|MB_ICONWARNING|MB_APPLMODAL);
	}


	// VKݒ
	FullSettings *pset = new FullSettings;

	pset->account = ndlg.GetAccountName();
	pset->protocol = RP_POP3;
	pset->server.auth = 1;
	pset->server.port = 0;
	RESET_DAV(interval);
	RESET_DAV(notify_term);
	RESET_DAV(notify_each);
	RESET_DAV(max_mail);
	RESET_DAV(show_term);
	RESET_DAV(preview_linenum);
	RESET_DAV(auto_preview);

	CSettingDlg dlg(*pset, *m_pdef);
	if( dlg.DoModal(m_hInstance, m_hDlgWnd) == IDOK ){
		AccNoList *noList = new AccNoList;

		noList->push_back(ACCNO_SINGLE);
		noList->push_back(m_nextAccNo);
		if( m_pmap->insert(std::make_pair(pset->account, noList)).second ){
			if( m_plist->insert(std::make_pair(m_nextAccNo++, pset)).second ){
				UpdateList();
				return;
			}else{
				m_pmap->erase(pset->account);
			}
		}
		delete noList;
	}

	delete pset;
}

void CSinglePage::OnClickDelete()
{
	HWND hList = GetDlgItem(IDC_LIST);
	INT iSelected = ListView_GetSelectionMark(hList);
	AccountList::iterator i;
	AccountMap::iterator mi;

	i = m_plist->find(GetListItemData(hList, iSelected));
	if( i != m_plist->end()  ){
		mi = m_pmap->find(i->second->account);
		if( mi != m_pmap->end() ){
			delete mi->second;
			m_pmap->erase(mi);
		}
		delete i->second;
		m_plist->erase(i);

		UpdateList();

		if( iSelected > 0 ){
			ListView_SetItemState(hList, iSelected-1, LVIS_SELECTED, LVIS_SELECTED);
			ListView_SetSelectionMark(hList, iSelected-1);
		}
	}
}

void CSinglePage::OpenSettingDialog()
{
	HWND hList = GetDlgItem(IDC_LIST);
	INT iSelected = ListView_GetSelectionMark(hList);
	AccountList::iterator i;
	
	i = m_plist->find(GetListItemData(hList, iSelected));
	if( i != m_plist->end()  ){
		FullSettings set = *(i->second);
		CSettingDlg dlg(set, *m_pdef);

		if( dlg.DoModal(m_hInstance, m_hDlgWnd) == IDOK ){
			*(i->second) = set;
			UpdateList();
		}
	}
}

//*******************************************************************
// ̑
//*******************************************************************
void CSinglePage::UpdateList() const
{
	int iItem;
	HWND hList;
	LVITEM lvi;
	std::string url;

	hList = GetDlgItem(IDC_LIST);
	::SendMessage(hList, LVM_DELETEALLITEMS, 0, 0);

	iItem = 0;
	lvi.mask = LVIF_TEXT|LVIF_PARAM;
	for( AccountList::const_iterator i = m_plist->begin(); i != m_plist->end(); ++i ){
		const FullSettings &set = *(i->second);

		lvi.iItem = iItem;
		lvi.iSubItem = COL_ACCOUNT;
		lvi.pszText = (LPSTR)set.account.c_str();
		lvi.lParam = i->first;
		ListView_InsertItem(hList, &lvi);

		FormatUrl(set, url);
		ListView_SetItemText(hList, iItem, COL_URL, (LPSTR)url.c_str());
		iItem++;
	}
}

void CSinglePage::FormatUrl(const FullSettings &set, std::string &url) const
{
	char buf[16];

	url = (set.protocol == RP_POP3) ? "pop://": "imap://";
	if( set.server.user.length() > 0 ) url += set.server.user + "@";
	url += set.server.host;
	if( (set.server.port > 0) 
		&& (set.server.port != ((set.protocol == RP_POP3) ? POP3_PORT: IMAP4_PORT)) )
	{
		_itoa_s(set.server.port, buf, 10);
		url += ":";
		url += buf;
	}
	url += "/";
	if( set.server.auth > 0 ) url += (set.protocol == RP_POP3) ?
		CPop3Server::GetAuthTypeName(set.server.auth):
		CImap4Server::GetAuthTypeName(set.server.auth);
}

int CSinglePage::GetListItemData(HWND hList, int nItem)
{
	LVITEM item;

	item.mask = LVIF_PARAM;
	item.iSubItem = 0;
	item.iItem = nItem;
	if( ListView_GetItem(hList, &item) ){
		return item.lParam;
	}
	return -1;
}

