#pragma once

class CThreadManager
{
private:
	HANDLE m_end;
	CRITICAL_SECTION m_cs;
	int m_active;

public:
	CThreadManager()
	{
		Init();
	}
	~CThreadManager()
	{
	}

	void Cleanup()
	{
		while( WaitForSingleObjectEx(m_end, INFINITE, TRUE) != WAIT_OBJECT_0 );
		CloseHandle(m_end);
		DeleteCriticalSection(&m_cs);
	}
	void Enter()
	{
		EnterCriticalSection(&m_cs);
		if( m_active <= 0 ) ResetEvent(m_end);
		m_active++;
		LeaveCriticalSection(&m_cs);
	}
	void Leave()
	{
		EnterCriticalSection(&m_cs);
		m_active--;
		if( m_active <= 0 ) SetEvent(m_end);
		LeaveCriticalSection(&m_cs);
	}

private:
	void Init()
	{
		m_active = 0;

		InitializeCriticalSection(&m_cs);
		m_end = CreateEvent(NULL, FALSE, TRUE, NULL);
		_ASSERT(m_end != INVALID_HANDLE_VALUE);
	}
};

