#pragma once

#define MK_GID(n, k, m) ((((n) & 0xFF) << 24) | (((k) & 0xFF) << 16) | ((m) & 0xFFFF))

#pragma warning( disable: 4201 )
union GID{
	struct {
		u_short mail_id;
		u_char chkr_id;
		u_char conn_id;
	};
	u_int gid;
};
#pragma warning( default: 4201 )

const u_int INVALID_GID = (u_int)-1;

class CGID
{
public:
	const static int GIDS_LEN = 8;

private:
	GID m_g;

public:
	CGID(u_int g)
	{ m_g.gid = g; }
	CGID(const CGID &g)
	{ m_g.gid = g.m_g.gid; }
	u_int gid() const
	{ return m_g.gid; }
	u_char conn_id() const
	{ return m_g.conn_id; }
	u_char chkr_id() const
	{ return m_g.chkr_id; }
	u_short mail_id() const
	{ return m_g.mail_id; }
//	operator int() const
//	{ return m_g.gid; }
	operator u_int() const
	{ return m_g.gid; }
	void ToStr(LPSTR str) const
	{
		const static char tbl[] = "0123456789ABCDEF";

		for( int i = 0; i < GIDS_LEN; i++ ){
			str[GIDS_LEN-i-1] = tbl[(m_g.gid >> (i << 2)) & 0xF];
		}
		str[GIDS_LEN] = '\0';
	}
};
