#pragma once
#pragma warning( disable: 4702 )
	#include <map>
	#include <vector>
#pragma warning( default: 4702 )
#include <string>

enum ComLogType
{
	RC_NOLOG,
	RC_COM,
	RC_NEW,
};

enum RE_PROTOCOL
{
	RP_ERROR,
	RP_POP3,
	RP_IMAP4,
};

enum RE_MARK
{
	RW_NONE,
	RW_NEW,
	RW_RECENT,
	RW_PREVIEW,
	NUM_OF_MARK,
};

enum RE_SECURITY
{
	RS_NONE,
	RS_SSL,
	RS_STLS,
	NUM_OF_SECURITY
};


// for CMailCheckerThread
struct CheckerSettings
{
	RE_PROTOCOL protocol;
	int preview_linenum;
	int interval;
	int max_mail;
	int max_auto_preview;
	std::string mua_option;
	bool auto_preview;
};

// for CRiffNsmProx
struct UISettings
{
	std::string account;
	bool notify_each;
	bool bDoLog;
	NotifyIconType mail_notify_type;
	NotifyIconType mnum_notify_type;
	int show_term;
	int interval;
	int max_mail;
	int notify_term;
};

// for CMailServer
struct ServerInfo
{
	std::string host;
	std::string user;
	std::string pass;
	RE_SECURITY security;
	int auth;
	int timeout;
	u_short port;
	bool use_async;
	bool keep_con;
	bool bDoLog;
};

// for CMailChecker
struct AccSettings
{
	CheckerSettings c_set;
	UISettings u_set;
	ServerInfo info;
};

struct DefAndValue
{
	bool use_default;
	int value;
};

// for CSettingDlg
struct FullSettings
{
	std::string account;
	std::string mua_option;
	RE_PROTOCOL protocol;
	ServerInfo server;

	DefAndValue interval;
	DefAndValue notify_term;
	DefAndValue notify_each;
	DefAndValue max_mail;
	DefAndValue show_term;
	DefAndValue preview_linenum;
	DefAndValue auto_preview;
};

// for CRiffSettings
struct DefaultSettings
{
	bool notify_each;
	bool auto_preview;
	int interval;
	int notify_term;
	int max_mail;
	int show_term;
	int preview_linenum;
	int font_size;
	int max_notify;
	int timeout;
	int max_auto_preview;
	RE_MARK mark_type;
	std::string font_name;
	std::string mua_path;
	ComLogType comlog_type;
	NotifyIconType mail_notify_type;
	NotifyIconType mnum_notify_type;
};

#define ACCNO_SINGLE	(-1)

typedef std::vector<int> AccNoList;
typedef std::map<int, FullSettings*> AccountList;
typedef std::map<std::string, AccNoList*> AccountMap;
